set_property PACKAGE_PIN Y9 [get_ports {clk}];  # "GCLK"

set_property PACKAGE_PIN Y21  [get_ports {frame[0]}];  # "VGA-B1"
set_property PACKAGE_PIN Y20  [get_ports {frame[1]}];  # "VGA-B2"
set_property PACKAGE_PIN AB20 [get_ports {frame[2]}];  # "VGA-B3"
set_property PACKAGE_PIN AB19 [get_ports {frame[3]}];  # "VGA-B4"
set_property PACKAGE_PIN AB22 [get_ports {frame[4]}];  # "VGA-G1"
set_property PACKAGE_PIN AA22 [get_ports {frame[5]}];  # "VGA-G2"
set_property PACKAGE_PIN AB21 [get_ports {frame[6]}];  # "VGA-G3"
set_property PACKAGE_PIN AA21 [get_ports {frame[7]}];  # "VGA-G4"
set_property PACKAGE_PIN AA19 [get_ports {Hsync}];  # "VGA-HS"
set_property PACKAGE_PIN V20  [get_ports {frame[8]}];  # "VGA-R1"
set_property PACKAGE_PIN U20  [get_ports {frame[9]}];  # "VGA-R2"
set_property PACKAGE_PIN V19  [get_ports {frame[10]}];  # "VGA-R3"
set_property PACKAGE_PIN V18  [get_ports {frame[11]}];  # "VGA-R4"
set_property PACKAGE_PIN Y19  [get_ports {Vsync}];  # "VGA-VS"

set_property PACKAGE_PIN P16 [get_ports {set_cell}];  # "BTNC"
set_property PACKAGE_PIN R16 [get_ports {move_down}];  # "BTND"
set_property PACKAGE_PIN N15 [get_ports {move_left}];  # "BTNL"
set_property PACKAGE_PIN R18 [get_ports {move_right}];  # "BTNR"
set_property PACKAGE_PIN T18 [get_ports {move_up}];  # "BTNU"

set_property PACKAGE_PIN F22 [get_ports {switch_mode}];  # "SW0"

set_property IOSTANDARD LVCMOS33 [get_ports -of_objects [get_iobanks 33]];
set_property IOSTANDARD LVCMOS18 [get_ports -of_objects [get_iobanks 34]];
set_property IOSTANDARD LVCMOS18 [get_ports -of_objects [get_iobanks 35]];
set_property IOSTANDARD LVCMOS33 [get_ports -of_objects [get_iobanks 13]];
